MSDN Library Help

MSDN, the Microsoft Developer Network, is the essential reference for developers who use Microsoft development tools or target any Windows or Internet platform. The MSDN Library contains more than 1.1 GB of technical programming information, including sample code, the Developer Knowledge Base, Visual Studio documentation, SDK documentation, technical articles, conference and seminar papers, and technical specifications. For more information on MSDN subscriptions, read the document MSDN Subscriptions or visit the MSDN Web site at http://www.microsoft.com/msdn/join/subscriptions.htm.

The MSDN Library is now the exclusive source for all Microsoft Visual Studio product documentation and other essential programming information. This help document shows how to work with the MSDN Library to find the information you need when you need it.

Contents

Understanding the MSDN Library Viewer

Locating Information in the MSDN Library
Navigating Using the Table of Contents
Finding Information with the Index
Finding Information with Full-Text Search
Creating a List of Favorite Topics

Common Tasks in the MSDN Library
Creating and Using Subsets
Copying Topics
Printing Topics
Retrieving Samples
Accessibility and Customizing the Viewer's Appearance
Connecting to the Internet


Understanding the MSDN Library Viewer

This version of the MSDN Library is built using the Microsoft HTML Help system. HTML Help files are displayed in a browser-like window, not in the full version of Internet Explorer with all its toolbars, favorites lists, and icons visible to the end user, but in a three-paned help window. The top pane contains the toolbar, the left pane contains the navigation methods, and the right pane displays the topic—with all the functionality of the browser intact. Anything you can display in Internet Explorer can also be displayed in HTML Help. The navigation pane contains the Contents, Index, Search, and Favorites tabs. By clicking topics in the table of contents, the Index, or the Favorites list you can explore any information within the Library. From the Search tab you can locate every occurrence of a word or phrase that may be contained in any topic.

Viewing topics

In a topic, you can click underlined words to see other information related to the topic.

  • To link to another topic, link to a Web page, link to a list of other topics, or link to an application, click the colored underlined words.

  • To select other topics containing related information, click the underlined words, "See Also," which may appear at the beginning of a topic, and then click the title of the topic you want to view.

  • To see whether a word or phrase contained in a topic is in the Index, select (highlight) the word or phrase and press F1.

  • When searching for topics, use Boolean operators to refine your search.

  • If you are viewing content from the Web in the topic pane, use the Stop and Refresh buttons on the toolbar to interrupt a download or refresh the content.


Locating Information in the MSDN Library

There are several methods for finding the information you need, and numerous ways to combine methods so that your search is quick and efficient. The options discussed below are accessible in the navigation pane in the left part of the MSDN Library viewer.

To find a topic from the viewer's navigation pane

  • Table of Contents Click the Contents tab to browse through topics by title. The table of contents is an expandable list of everything that is available in the MSDN Library.

  • Keyword Index Click the Index tab to see a list of index entries, and then either type a word or scroll through the list. Similar to the index in a printed book, topics are often indexed under more than one entry.

  • Full-Text Search Click the Search tab to locate every occurrence of a word or phrase that may be contained in a topic. You can narrow your search by limiting it to a part of a collection or by defining subsets of topics that you specify.

  • Favorites Click the Favorites tab to create or access a list of favorite topics. You can easily mark favorite topics and return to them.

To view a topic found through any of these navigation methods, click the entry in the navigation pane to display the corresponding topic in the topic pane.

F1 lookups

To find a topic from your development environment, press the F1 key to display the MSDN Library browser. F1 works for keywords, API functions, error messages, and in dialog boxes to help you discover the purpose of a particular control.

To hide or show the navigation pane

The navigation pane is displayed by default in the MSDN Viewer. If you want to hide it, click View from the toolbar, then uncheck the Navigation Tabs option. To display the navigation pane, click View from the toolbar and check the Navigation Tabs option.

Note If you close the browser with the navigation pane hidden, it will reopen that way.


Navigating Using the Table of Contents

To view the table of contents, click the Contents tab in the navigation pane.

To expand or contract a node

  • To open an item in the table of contents, click the plus sign (+) in front of a node to expand that node, then double-click the item you want to see.

  • Click the minus sign (-) in front of a node to contract that node.

  • You also can navigate the nodes by using the UP and DOWN arrow keys to move vertically, and the LEFT and RIGHT arrow keys to expand and contract the nodes.

  • You can also use the Previous and Next buttons on the toolbar.

To view a topic, click the topic in the table of contents.

To find where a topic is located in the table of contents

On the toolbar, click the Locate button. The table of contents will synchronize to the topic you are viewing.

Note If you are interested only in a portion of the table of contents, you can define a subset that will display only that information. For more information, see Creating and Using Subsets.


Finding Information with the Index

The Index tab contains a list of keywords that have been associated with many of the MSDN Library topics. This index is similar to a book index.

To locate a topic using the index

  1. In the navigation pane, click the Index tab and then either type or select a keyword you want to find information about.

  2. After you have selected a keyword, click Display.

  3. From the list of topics found, select the topic you want and then click Display.

Note When a subset is selected and you click the Index tab in the navigation pane, the entire Index will appear, but keywords that are not included in the active subset appear dimmed and are unavailable.


Finding Information with Full-Text Search

A basic search of topics consists of the word or phrase you want to find. You can use wildcard expressions, nested expressions, Boolean operators, similar word matches, the previous results list, or topic titles to refine your search.

To perform a full-text search

  1. In the navigation pane, click the Search tab and then type the word or phrase you want to find. Use the right-arrow button to add Boolean operators to your search.

  2. Click List Topics.

    Your search will return the first 500 hits. If you want to sort the topic list, click Title, Location, or Rank.

  3. Highlight the topic you want, and then click Display. (Alternatively, you can display any topic by double-clicking it.)

To refine a full-text search

You can refine a basic search by using wildcard expressions, nested expressions, and Boolean operators. You can also search only on the previous results list, request similar word matches, or search only the titles of topics in the table of contents.

  • To refine a search to include just the last group of topics you searched, select the Search previous results check box.

  • To match similar spellings in a full-text search, select the Match similar words check box.

    When Match similar words is selected, the viewer matches minor grammatical variations of the word or phrase you entered, as well as the word or phrase itself. For example, if you entered "add" and selected this box, the Library viewer would find "add", "adds", and "added". This option is independent of other options or syntax. If you do a titles-only search, variations in titles will be matched. If you use quotes (or any other query operator) any variation of the word can appear; for example, "stemmed search" will also match "stemming search".

  • To search for words in document titles only, select the Search titles only check box.

To highlight words in searched topics

When searching for words in Help topics, you can specify that each occurrence of the word or phrase you searched for is highlighted in the topics that are found.

  • On the Viewer toolbar, click View and then click Highlights to add a checkmark to this option to highlight all instances of the word or phrase.

  • On the Viewer toolbar, click View and then click Highlights to remove the checkmark from this option and to turn off this feature.

Search Syntax

The basic rules for formulating queries are as follows:

  • Searches are not case-sensitive, so you can type your search in uppercase or lowercase characters.

  • You can search for any combination of letters (a–z) and numbers (0–9). You cannot search for single letters (a, b, c, etc.) and the following reserved words: an, and, as, at, be, but, by, do, for, from, have, he, in, it, not, of, on, or, she, that, the, there, they, this, to, we, which, with, you.

  • Punctuation marks such as the period (.), colon (:), semicolon (;), comma (,), and hyphen (-) are ignored during a search.

  • Group the elements of your search using "double quotes" or (parentheses). You cannot search for quotation marks.

Note If you are searching for a filename with an extension, you should group the entire string in double quotes, ("filename.ext"). Otherwise, the search will treat the period as an OR operator.

Words, Phrases, and Wildcards

You can search for words or phrases and use wildcard expressions. The table below describes the results of these different kinds of searches.

Search for | Example | Results
A single word | Select | Topics that contain the word "select." (You will also find its grammatical variations, such as "selector" and "selection").
A phrase | "new operator" –or– 'new operator' | Topics that contain the literal phrase "new operator" and all its grammatical variations. Without the quotation marks, the query is equivalent to specifying a new AND operator, which will find topics containing both of the individual words, instead of the phrase.
Wildcard expressions | Esc* | Topics that contain the terms "ESC," "escape," "escalation," and so on. The asterisk cannot be the only character in the words.
 | 80?86 | Topics that contain the terms "80186," "80286," "80386," and so on. The question mark cannot be the only character in the term.
 | *86 | Topics that contain the terms "386," "486," "x86," "QEMM386," "8086," and so on.

Operators: AND, OR, NOT, and NEAR

The AND, OR, NOT, and NEAR operators allow you to refine your search. The following table shows how to use each of these operators.

Search for | Example | Results
Both terms in the same topic | dib AND palette –or– dib & palette | Topics containing both the words "dib" and "palette."
Either term in a topic | raster OR vector –or– raster | vector< | Topics containing either the word "raster" or the word "vector."
The first term without the second term | ole NOT dde –or– ole ! dde | Topics containing the word "OLE," but not the word "DDE."
Both terms in the same topic, close together | user NEAR kernel | Topics containing the word "user" within eight words of the word "kernel."

Rules for Nested Expressions

The basic rules for searching topics using nested expressions are as follows:

  • You can use parentheses to nest expressions within a query. The expressions in parentheses are evaluated before the rest of the query.

  • If a query does not contain a nested expression, it is evaluated from left to right. For example, "Control NOT active OR dde" finds topics containing the term "control" without the term "active", or topics containing the term "control" and not "dde". (On the other hand, "control NOT (active OR dde)" finds topics containing the term "control" without either of the terms "active" or "dde".)

  • Nesting allows you to create more complex search expressions. For example, "control AND ((active OR dde) NEAR window)" finds topics containing the term "control" along with the terms "active" and "window" close together, or containing "control" along with the terms "dde" and "window" close together.

  • You cannot nest expressions more than five levels deep.


Creating a List of Favorite Topics

To create a list of favorite topics

  1. In the navigation pane, click the Contents, Index, or Search tab and open a topic you want to make a favorite topic.

  2. Click the Favorites tab. The topic that you opened in step 1 will be displayed in the Current topic area.

  3. Click Add to add the topic to your favorites list.

    Note If you want to rename the displayed topic, type the new name in the Current topic area and then click Add.

To return to a favorite topic

  • Highlight the topic and then click Display.

    –Or–

  • Double-click the topic name.

To remove a favorite topic

  • Select the topic and then click Remove.


Common Tasks in the MSDN Library

The following topics contain information about common MSDN Library tasks that do not involve locating information.

Creating and Using Subsets

Copying Topics

Printing Topics

Retrieving Samples

Accessibility and Customizing the Viewer's Appearance

Connecting to the Internet


Creating and Using Subsets

You can use MSDN Library subsets to display only the information you are interested in. By selecting a subset, you filter the topics that appear in the table of contents, full-text search, and F1 look-up. When a subset is selected and you click the Index tab in the navigation pane, the entire Index will appear, but keywords that are not included in the active subset appear dimmed and are unavailable.

Subset definition is based on the structure of the table of contents. The MSDN Library ships with predefined subsets based on common ways of using the Library. You can use these predefined subsets to filter topics or you can define your own subsets. You can use a predefined subset as a starting point and save the results with a new name or you can define subsets from the entire table of contents. Subsets that you create are added to the list of available subsets and are saved between sessions.

To select the active subset

In the navigation pane, select a subset from the Active Subset dropdown menu. If no subsets are defined, the only option is Entire Collection.

To define a subset

  1. From the View menu, click Define Subset... .

  2. In the Select subset to display dropdown list, select New to start with all nodes available, or select an existing subset to use as the base for your subset.

  3. Select a node in the Available Items list box. Click Add.

  4. Continue adding nodes until the subset is complete.

  5. When the subset is complete, enter a title in the Save new subset as edit box and click Save.

  6. Click Close.

Note When you add a node to a subset, the top-level node (book) takes precedence, so if you add something from a book and later add the whole book, the item added first doesn't appear twice.

To edit or remove a subset

You can remove a node from the subset by highlighting it in the Items included in current subset list box and clicking Remove. The user interface contains an Add All and a Remove All button to allow a quick way to accomplish these tasks.

Note Subsets cannot be merged or combined.


Copying Topics

To copy a topic

  1. In the topic pane, right-click inside the topic you want to copy, and then click Select All.

  2. Inside the topic, right-click again, and then click Copy.

  3. This copies the topic to the Clipboard.

  4. Open the document where you want to paste the topic.

  5. Click the place in your document where you want the information to appear.

  6. On the Edit menu, click Paste.

Note If you want to copy only part of a topic, select the part you want to copy, right-click your selection, and then click Copy.


Copying and Printing Topics

Printing Topics

To print the current topic

  1. In the topic pane, right-click in the topic you want to print.

  2. Click Print.

–Or–

  1. On the File menu, click Print.

  2. In the Print dialog box, check off the Print the current page option, and then click OK.

To print several documents under one heading

If you print from the Contents tab, you have the option to print a topic that contains subtopics.

  1. In the contents pane, select (single-click) the topic you want to print.

  2. On the File menu, click Print.

  3. In the Print dialog box, check off the Print everything contained in the current heading option, and then click OK.


Retrieving Samples

Every tool in the Visual Studio edition of the MSDN Library includes product-specific samples. For more information on these samples, read the Visual Studio document titled Explore the Samples.

The source files for many samples are accessible from the sample abstracts, which describe what each sample application does. For each sample, you can view the individual source files or copy the source files onto your hard disk to build the application yourself.

To locate sample applications, search for "samples" using the keyword index.

To use a sample application

  1. Click on the link inside the sample abstract to open the sample's view/copy dialog box. This dialog box displays a listing of all the files associated with the sample application.

  2. To look at a specific file, select the file in the file list and double-click it, or click the View button. The file is copied to your system and displayed in a source window.

    Note Only text files may be viewed. Attempting to view a binary file will disable the View button.

  3. If you want to copy the files onto your hard drive, select the desired files and click the Copy button, or click the Copy All button to copy the entire sample.

    Note Both the Copy and Copy All buttons let you specify a target directory for the files being copied.


Customizing the Viewer's Appearance

Accessibility and Customizing the Viewer's Appearance

You can customize the MSDN Library browser as follows.

To change the font size in the topic pane

  • From the View menu, mouse over the Fonts item and then select the font size you want.

    Note This changes the font size only in the topic pane of the viewer.

To make the navigation or topic panes wider or narrower

  • Point to the divider between the two panes. When the pointer changes to a double-headed arrow, hold down the left mouse button and drag the divider right or left.

To reposition the viewer on your screen

  • Click the title bar and drag the viewer to a new position.

Note If you close the viewer, it will reopen using the last size and position settings you selected.

To customize Internet Explorer viewer options

From the View menu, choose Internet Options. This will launch the Internet Explorer Internet Options dialog box. From this dialog box you can change viewer options, including colors, fonts, and accessibility settings. Note that these settings will also be applied to all content displayed in Internet Explorer, including Web pages.


Connecting to the Internet

Throughout the MSDN Library there are many internal links, as well as links to external Web sites. The MSDN viewer (which uses the Internet Explorer browser engine) defaults to Offline Mode, but switches to Online Mode when a link to an external Web site is activated. Depending on your Internet connection, one of the following things may happen when you click a link to an external Web site.

  • If your computer is on a network that is connected to the Internet, you won't receive any connection prompts when you click a link to an external Web site. The exception to this is if your Internet access from the network has been restricted. If you are unsure of the status of your Internet access, ask your network administrator.

  • If you use a dial-up connection to access the Internet, you will be prompted to dial into your ISP and connect to the Internet when you click a link to an external Web site. This will not occur if you are already connected to the Internet.

Note Because the MSDN viewer uses the Internet Explorer browser engine, the security settings that you have set for Internet Explorer will also apply to any external Web sites you link to when viewing the MSDN Library. If your security setting for the Internet zone is set to High, you may receive security warning messages when accessing external Web sites. For more information about Internet Explorer security settings, see Internet Explorer Help.


Installing the MSDN Library

You are not required to uninstall previous versions of the MSDN Library that use InfoViewer 5.0 technology. For example, the July 1998 MSDN Library and all earlier libraries will coexist with the Visual Studio 6.0 edition of the MSDN Library.

If you do wish to uninstall any Library, always use the Add/Remove Programs option from the Control Panel or the Setup program from the CD of the MSDN Library you wish to uninstall.

For more information, see the following topics.

Installation Options

Installing Internet Explorer with the MSDN Library

Uninstalling the MSDN Library


Installation Options

During Setup you will be asked to choose between Typical, Full, and Custom installation options. The Typical setup option allows you to run the MSDN Library from the CD. Setup will copy the minimum set of files to your local hard disk. These files include the MSDN viewer system files, contents index files, and Help files that are used by the Visual Studio development products.

Custom installation allows you to specify local installation of a subset of the MSDN Library. The files you select will be copied to your local hard disk along with the files mentioned in the Typical Setup description. You will still see the entire Library table of contents. If you select content that has not been installed locally, you will be prompted to insert the MSDN Library CD.

You can speed up your searches and reduce the amount of CD swapping that is needed by selecting certain custom installation options.

To reduce CD swapping

  • Install the documentation you use most frequently to your local hard disk. This will reduce the need to access the MSDN CD-ROM, freeing up your CD drive for other uses.

For faster full-text searches

  • Install the Full-Text Index to your local hard disk.

Note The Full-Text Index is around 100 MB (the exact size is shown in the custom installation dialog box), so be sure that you have enough hard disk space before installing it.

To install additional documentation or the Full-Text Index

  1. Click Start, Settings, then Control Panel.

  2. Double-click Add/Remove Programs. The Add/Remove Programs Properties dialog box appears.

  3. From the list of programs, select Microsoft Developer Network Library – VS <version X>.

  4. Click Add/Remove. MSDN VS <version X> Setup will start.

  5. Click the Add/Remove option. The MSDN VS <version X> Custom dialog box appears. This is the same dialog box that is seen when a custom install is chosen during setup.

  6. Check off the items you want to install.

  7. Click Continue to complete the installation process.

Running the MSDN Library from a Network Folder

Note The MSDN Library is licensed to a single user. (For more information, see the MSDN Master license agreement file. It is named EULA.TXT and resides on Disc 1 in the Setup directory.) This section applies only to those individuals or organizations who have acquired additional user licenses for the MSDN Library via the Microsoft Open License Program (MOLP) or otherwise. You may share the Library only to licensed users. For information on MOLP, contact your software reseller, or visit http://www.microsoft.com/select/.

An efficient way for one or several licensed users to access the MSDN Library is to create a shared installation folder on a network computer's hard drive, and make it accessible to the licensed users in your group. MSDN strongly recommends that you copy all the files in the Library to a shared hard disk drive rather than trying to share a CD-ROM drive. This yields better performance for multiple users accessing the Library over a network.

To correctly create the folder, all contents from the MSDN Library Disc 1 and Disc 2 must be combined into one folder with the identical directory structure as Disc 1. You can easily create this folder by first copying all files from Disc 1 to the folder and then copying all files from Disc 2 to the same location.

You must first select a hard disk drive with sufficient space. A minimum of 1.5-GB hard disk drive space is recommended. Depending on your operating system and hardware, the Library will probably take between 775 MB and 1.5 GB of space on your hard disk drive.

To correctly create the network installation folder, all contents from the MSDN Library Disc 1 and Disc 2 must be combined into one folder with the identical directory structure as Disc 1. Setup will fail if a user attempts a full installation of the MSDN Library from a share that has the contents of Disc 1 and Disc 2 in separate folders.

Important Do not share the network installation folder while you are copying. It will likely cause you problems if someone runs Setup while you are copying the Library.

To copy the Library contents to a network folder

Complete the following steps in order to place the Library on a network folder for better performance over a network.

  1. Put the CD-ROM drive on a system that has read/write/update permission to the network installation computer. The process will run much faster if the CD-ROM drive and the hard disk drive are on the same computer.

  2. Copy all files from MSDN Library Disc 1 to the folder and then copy all files from Disc 2 to the same location.

  3. Share the hard disk drive (that is, make it accessible to users). Go to a different computer and run Setup on the client computer from the shared hard disk drive. After you have verified that the Library runs properly from the client computer, you can announce to your users that it's ready for their use.

That's all there is to it. Pretty simple, really—copy everything to the same folder while no one is using the CD-ROM drive from which you're copying or the shared hard drive to which you're copying. Then verify that it works by running Setup and opening the Library from a client computer.

Here are some additional guidelines for installing the Library to a network folder:

  • The folder should be made read-only after you have created it.

  • The network computer should have enough bandwidth to handle the anticipated load.

  • The network computer should be able to handle the required number of concurrent client connections.

  • The network computer should not use a compressed file system, unless this is commensurate with the hardware and the anticipated load.


Installing Internet Explorer with the MSDN Library

In order for the MSDN Library to function properly, you need to have version 3.02c or higher of a released version of Microsoft Internet Explorer installed on your system. If you do not have one of these versions installed, MSDN Setup will ask whether you want to exit Setup to install a newer version of Internet Explorer.

If you select Yes, MSDN Setup will halt and display a dialog box reading, "MSDN Setup was not completed successfully." You then must click OK and manually install Internet Explorer. For your convenience, the latest version Internet Explorer is included with your CDs, or connect to http://www.microsoft.com/ie/ to download the latest version. Refer to the Visual Studio 6.0 Readme file for more Internet Explorer setup instructions. If you are using Windows NT 4.0, you may need to install the Windows NT Service Pack 3. Check http://www.microsoft.com/support/winnt/ for more details.

If you select No, MSDN Setup will continue with the installation.


Uninstalling the MSDN Library

To uninstall the MSDN Library, use Add/Remove Programs in Control Panel. Although multiple versions of the MSDN Library can coexist on your computer, you may want to uninstall an older version if you no longer need it.

To uninstall the MSDN Library

  1. Click Start, Settings, and then Control Panel.

  2. Double-click Add/Remove Programs. The Add/Remove Programs Properties dialog box appears.

  3. From the list of programs, select the version of Microsoft Developer Network Library that you want to uninstall.

  4. Click Add/Remove. MSDN <version> Setup will start.

  5. Click Remove All. This will remove all files from the version of the MSDN Library that you selected in step 3.

  6. Click Continue to complete the uninstallation process.